.code
_a_; eax = c, edx = bn
bn_add_carry_dword proc; uses ecx
	.if eax
		mov ecx,[edx].BN.dwSize
		inc ecx
		.if ecx <= BN_MAX_DWORD
			mov [edx].BN.dwArray[ecx*4-4],eax ; eax == carry
			mov [edx].BN.dwSize,ecx
			ret
		.endif
		IFDEF DEBUG
		invoke bn_error,T('overflow')
		ELSE
		invoke bn_error,0
		ENDIF
	.endif
	ret
bn_add_carry_dword endp
_a_; x = x + y
bn_add_ignoresign proc; uses edi,esi,edx,ecx,eax
	mov ecx,[edi].BN.dwSize
	mov edx,[esi].BN.dwSize
	cmp edx,ecx
	push edi
	cmova ecx,edx
	mov [edi].BN.dwSize,ecx; max
	lea esi,[esi].BN.dwArray
	lea edi,[edi].BN.dwArray
	xor eax,eax; clear carry
	.repeat
		mov edx,[esi]
		lea esi,[esi+4]
		adc [edi],edx
		dec ecx
		lea edi,[edi+4]
	.until ZERO?
	setc al
	jc @F
	pop edi
	ret; most probable case
@@:
	pop edx
	call bn_add_carry_dword
	ret
bn_add_ignoresign endp
_a_; edx = bn
bn_normalize proc; uses eax,ecx
	

	mov ecx,BN_MAX_DWORD
	.repeat
		mov eax,[edx].BN.dwArray[ecx*4-4]
		test eax,eax
		jnz @F
		dec ecx
	.until zero?
	mov [edx].BN.bSigned,ecx;FALSE
	inc ecx
@@:


	mov [edx].BN.dwSize,ecx
	ret
bn_normalize endp
_a_; x = x - y , x >= y
bn_sub_ignoresign proc uses edi esi;,ecx,eax,edx
	mov edx,edi
	mov ecx,[edi].BN.dwSize
	lea esi,[esi].BN.dwArray
	lea edi,[edi].BN.dwArray
	xor eax,eax; clear carry
	.repeat
		mov eax,[esi]
		lea esi,[esi+4]
		sbb [edi],eax
		dec ecx
		lea edi,[edi+4]
	.until ZERO?
	call bn_normalize
	ret
bn_sub_ignoresign endp
_a_; 0 if |X|=|Y|      1 if |X|>|Y|      -1 if |X|<|Y|
bn_cmp_array proc; uses edx,ecx,eax 
	mov edx,[edi].BN.dwSize
	mov ecx,[esi].BN.dwSize
	lea eax,[edx+1]; i = size + 1
	jmp @F
	.repeat
		dec eax
		jz @@Exit; done, equal
		mov edx,[edi].BN.dwArray[eax*4-4];bnX[i]
		mov ecx,[esi].BN.dwArray[eax*4-4];bnY[i]
@@:	.until edx != ecx
	xor eax,eax
	.if edx > ecx
		inc eax
	.else
		dec eax
	.endif
@@Exit:
	ret
bn_cmp_array endp
_a_;
bn_inc_ignoresign proc uses esi;,ecx,eax,edx
	mov edx,esi
	lea esi,[esi].BN.dwArray[0*4]
	xor eax,eax
	stc
	.repeat
		adc [esi],eax
		jnc @F
		lea esi,[esi+4]
		dec ecx
	.until zero?
	adc eax,eax
	call bn_add_carry_dword
@@:
	ret
bn_inc_ignoresign endp
_a_;
bn_dec_ignoresign proc uses esi;,ecx,eax,edx
	mov edx,esi
	lea esi,[esi].BN.dwArray[0*4]
	xor eax,eax
	stc
	.repeat
		sbb [esi],eax
		jnc @F
		lea esi,[esi+4]
		dec ecx
	.until zero?
@@:
	call bn_normalize
	ret
bn_dec_ignoresign endp

;
;	compare magnitudes
;
_a_
bnCmpAbs proc uses edi esi bnX:DWORD,bnY:DWORD
	mov edi,bnX
	mov esi,bnY
	call bn_cmp_array
	ret
bnCmpAbs endp
;
;	x = x + y
;
_a_
bnAdd proc uses edi esi ebx bnX:DWORD,bnY:DWORD
;----------------------;
;	+x + +y = +(x+y)   ;
;	-x + -y = -(x+y)   ;
;	+x + -y = x-y      ;
;	-x + +y = y-x      ;
;----------------------;
	mov edi,bnX
	mov esi,bnY
	mov eax,[edi].BN.bSigned
	mov ebx,[esi].BN.bSigned
	.if eax == ebx
		call bn_add_ignoresign  
		ret
	.endif
	bnCreateX edi,esi
	invoke bnMov,edi,bnX
	invoke bnMov,esi,bnY
	call bn_cmp_array
	test eax,eax
	.if sign?
		xchg esi,edi
		mov [edi].BN.bSigned,ebx
	.endif
	call bn_sub_ignoresign
	invoke bnMov,bnX,edi
	bnDestroyX
	ret
bnAdd endp
;
;	x = x - y
;
_a_ 
bnSub proc uses edi esi ebx bnX:DWORD,bnY:DWORD
;----------------------;
;	+x - +y = x-y      ;
;	+x - -y = +(x+y)   ;
;	-x - +y = -(x+y)   ;
;	-x - -y = y-x      ;
;----------------------;
	mov edi,bnX
	mov esi,bnY
	mov ebx,[edi].BN.bSigned
	mov eax,[esi].BN.bSigned
	.if eax != ebx
		call bn_add_ignoresign
		ret 
	.endif
	bnCreateX edi,esi
	invoke bnMov,edi,bnX
	invoke bnMov,esi,bnY
	call bn_cmp_array
	test eax,eax
	sets dl
	movzx edx,dl
	.if sign?
		xchg esi,edi
	.endif
	xor ebx,edx
	mov [edi].BN.bSigned,ebx
	call bn_sub_ignoresign
	invoke bnMov,bnX,edi
	bnDestroyX
	ret
bnSub endp
;
;	increment
;
_a_
bnInc proc uses esi bn:DWORD
	mov esi,bn
	.if ![esi].BN.bSigned
		call bn_inc_ignoresign
		ret
	.endif
	call bn_dec_ignoresign
	ret
bnInc endp 
;
;	decrement
;
_a_
bnDec proc uses esi bn:DWORD
	mov esi,bn
	.if ![esi].BN.bSigned
		call bn_dec_ignoresign
		ret
	.endif
	call bn_inc_ignoresign
	ret
bnDec endp 
;
;	shift left by 1
;	bn = bn*2
;	
_a_
bnShl1 proc uses esi bn:DWORD 
	mov esi,bn
	xor eax,eax
	mov ecx,[esi].BN.dwSize
	lea esi,[esi].BN.dwArray
	.repeat
		mov edx,[esi]
		lea esi,[esi+4]
		adc edx,edx;rcl dword ptr [esi],1
		dec ecx
		mov [esi-4],edx
	.until zero?
	adc eax,eax 
	mov edx,bn
	.if !eax
		ret ; most probable case
	.endif
	call bn_add_carry_dword
	ret
bnShl1 endp
;
;	shift right by 1
;	bn = bn div 2
;	
_a_
bnShr1 proc uses esi bn:DWORD
	mov esi,bn
	xor eax,eax
	mov ecx,[esi].BN.dwSize
	lea esi,[esi].BN.dwArray[ecx*4-4]
	.repeat
		mov edx,[esi]
		lea esi,[esi-4]
		rcr edx,1
		dec ecx
		mov [esi+4],edx
	.until zero?
	adc eax,eax
	mov edx,bn
	push eax 
	call bn_normalize
	pop eax
	ret
bnShr1 endp
;
;	shift left by sc 
;
_a_
bnShl proc uses edi esi ebx bn:DWORD,sc:DWORD
	mov edx,sc
	mov esi,bn
	shr edx,5
	mov ebx,[esi].BN.dwSize
	.if !zero?
		; do 32 bit shifts
		lea eax,[ebx+edx]
		.if eax > BN_MAX_DWORD
			IFDEF DEBUG
			invoke bn_error,T('overflow')
			ELSE
			invoke bn_error,0
			ENDIF
			ret
		.endif
		mov [esi].BN.dwSize,eax
		lea edi,[esi].BN.dwArray[eax*4-4]
		lea esi,[esi].BN.dwArray[ebx*4-4]
		std
		mov ecx,ebx
		rep movsd
		mov ecx,edx
		xor eax,eax
		rep stosd
		cld
	.endif
	mov ecx,sc
	mov esi,bn
	and ecx,31
	.if !zero?
		; do <32 bit shifts
		xor eax,eax
		mov ebx,[esi].BN.dwSize
		lea esi,[esi].BN.dwArray[ebx*4-8]
		mov edx,[esi+4]
		shld eax,edx,cl
		mov edi,eax
		jmp @F
		.repeat
			mov eax,[esi]
			shld edx,eax,cl
			mov [esi+4],edx
			mov edx,eax
			sub esi,4
	@@:		dec ebx
		.until zero?
		shl edx,cl
		mov eax,edi
		mov [esi+4],edx
		.if eax
			mov edx,bn
			call bn_add_carry_dword
		.endif
	.endif
	ret
bnShl endp
;
;	anlogue
;
_a_
bnShr proc uses edi esi ebx bn:DWORD,sc:DWORD 
	mov edx,sc
	mov esi,bn
	shr edx,5
	mov ebx,[esi].BN.dwSize
	.if !zero?
		; do 32 bit shifts
		mov edi,esi
		.if edx >= ebx
			;invoke bn_error,T('out of range')
			invoke bnClear,bn
			ret
		.endif
		.if BN_IS_ZERO(esi)
			xor eax,eax
			ret
		.endif
		sub ebx,edx
		mov [edi].BN.dwSize,ebx
		lea esi,[esi].BN.dwArray[edx*4+4-4]
		add edi,BN.dwArray
		mov ecx,ebx
		rep movsd
		mov ecx,edx
		xor eax,eax
		rep stosd
	.endif
	mov ecx,sc
	mov esi,bn
	and ecx,31
	.if !zero?
		xor eax,eax
		mov ebx,[esi].BN.dwSize
		mov edx,[esi].BN.dwArray[0*4]
		shrd eax,edx,cl
		add esi,BN.dwArray
		mov edi,eax
		jmp @F
		.repeat
			mov eax,[esi+4]
			shrd edx,eax,cl
			mov [esi],edx
			mov edx,eax
			add esi,4
	@@:		dec ebx
		.until zero?
		shr edx,cl
		mov eax,edi
		mov [esi],edx
		mov edx,bn
		call bn_normalize
	.endif
	ret
bnShr endp
_a_; Standard Multiplication Algorithm
bn_mul_basecase proc
	xor eax,eax
	dwCARRY equ dword ptr [esp+pushad_eax]
	pushad
	mov ebp,[esp+pushad_ebx]
	xor ebx,ebx
	.repeat
		xor ecx,ecx
		xor edx,edx
		.repeat
			mov eax,[esi].BN.dwArray[ebx*4-4+4]
			mul dword ptr [edi].BN.dwArray[ecx*4-4+4]
			add eax,dwCARRY
			adc edx,0
			add [ebp].BN.dwArray[ecx*4-4+4],eax
			adc edx,0
			inc ecx
			mov dwCARRY,edx
		.until ecx >= [edi].BN.dwSize
		mov eax,dwCARRY
		add ebp,4
		inc ebx
		mov [ebp].BN.dwArray[ecx*4-4],eax
		xor eax,eax
		mov dwCARRY,eax
	.until ebx >= [esi].BN.dwSize
	popad
	ret
bn_mul_basecase endp
;
;	prod = x*y
;
_a_ 
bnMul proc uses ebx esi edi bnX:DWORD,bnY:DWORD,bnProd:DWORD

;---------------------;
; sign(x) xor sign(y) ;
;---------------------;

LOCAL tmpProd

	bnCreateX tmpProd
	mov esi,bnX
	mov edi,bnY
	.if !BN_IS_ZERO(esi) && !BN_IS_ZERO(edi) 
		mov eax,[esi].BN.dwSize
		mov ebx,tmpProd
		add eax,[edi].BN.dwSize
		.if eax <= BN_MAX_DWORD
			mov [ebx],eax
			call bn_mul_basecase
		.endif
		mov edx,tmpProd
		call bn_normalize

		mov eax,bnX
		mov ecx,bnY
		mov ebx,[eax].BN.bSigned
		xor ebx,[ecx].BN.bSigned
		mov eax,tmpProd
		mov [eax].BN.bSigned,ebx
		
	.endif
	invoke bnMov,bnProd,tmpProd
	bnDestroyX
	ret
bnMul endp
_a_
bn_square_basecase proc
	push ebp
	xor ebx,ebx
	.repeat
		mov eax,[esi].BN.dwArray[ebx*4-4+4]
		mul eax
		xor ebp,ebp
		add [edi].BN.dwArray[ebx*4-4+4],eax
		adc [edi].BN.dwArray[ebx*4-4+8],edx
		adc [edi].BN.dwArray[ebx*4-4+12],ebp
		lea ecx,[ebx+1]
		jmp @F
		.repeat
			mov eax,[esi].BN.dwArray[ebx*4-4+4]
			xor ebp,ebp
			mul [esi].BN.dwArray[ecx*4-4+4]
			add eax,eax
			adc edx,edx
			adc ebp,ebp
			add [edi].BN.dwArray[ecx*4-4+4],eax
			adc [edi].BN.dwArray[ecx*4-4+8],edx
			adc [edi].BN.dwArray[ecx*4-4+12],ebp
			inc ecx
@@:		.until ecx >= [esi].BN.dwSize
		add edi,4
		inc ebx
	.until ebx >= [esi].BN.dwSize
	pop ebp
	ret
bn_square_basecase endp
;
;	x = x*x (x = x^2)
;
_a_ 
bnSquare proc uses ebx esi edi bnX:DWORD
	LOCAL tmpProd
	bnCreateX tmpProd
	xor eax,eax
	mov esi,bnX
	inc eax
	mov edi,tmpProd
	cmp [esi].BN.dwSize,eax
	jne @F
	cmp [esi].BN.dwArray[0*4],eax
	je @@One
	dec eax
	cmp [esi].BN.dwArray[0*4],eax
	je @@Zero
@@:
	mov eax,[esi]
	add eax,eax
	.if eax <= BN_MAX_DWORD
		mov [edi],eax
		call bn_square_basecase
	.endif
	mov edx,tmpProd
	call bn_normalize

	invoke bnMov,bnX,tmpProd
	bnDestroyX
	ret

@@One:
@@Zero:
	invoke bnMovzx,bnX,eax
	bnDestroyX
	ret
	
bnSquare endp
;
;	quo = x div y
;	rem = x mod y
;
_a_
bnDiv proc uses edi esi ebx bnX:DWORD,bnY:DWORD,bnQuo:DWORD,bnRem:DWORD
LOCAL tempKvocijent,BitPos

	mov edi,bnY
	mov esi,bnX

	cmp [edi].BN.dwSize,1 ;	.if !BN_IS_ZERO(edi); DBZ
	jne @F
	cmp [edi].BN.dwArray[0],0
	je @@DivisionByZero
@@:	
	cmp [esi].BN.dwSize,1;	.if !BN_IS_ZERO(esi); DZ
	jne @F
	cmp [esi].BN.dwArray[0],0
	je @@DivideZero
@@:	
	
	invoke bnCmpAbs,bnX,bnY
	.if sdword ptr eax>0
 		; X > Y
		bnCreateX tempKvocijent,edi;tempRem
		invoke bnBits,esi
		lea ebx,[eax-1]
		.repeat
			invoke bnShl1,edi
			bt [esi].BN.dwArray[0],ebx
			sbb eax,eax
			neg eax
			or [edi].BN.dwArray[0],eax
			invoke bnCmpAbs,edi,bnY
			test eax,eax
			.if !SIGN?
				invoke bnSub,edi,bnY
				mov eax,tempKvocijent
				bts [eax].BN.dwArray[0],ebx
			.endif
			dec ebx
		.until SIGN?
		mov edx,tempKvocijent
		call bn_normalize

		.if bnRem
			invoke bnMov,bnRem,edi
		.endif
		invoke bnMov,bnQuo,tempKvocijent

		mov eax,bnX
		mov ecx,bnY
		mov edx,bnRem
		mov ebx,[eax].BN.bSigned
		.if edx
			mov [edx].BN.bSigned,ebx
		.endif
		xor ebx,[ecx].BN.bSigned
		mov eax,bnQuo
		mov [eax].BN.bSigned,ebx

		bnDestroyX
		ret
	.endif

	mov edi,bnX
	mov esi,bnY
	mov ebx,[edi].BN.bSigned
	xor ebx,[esi].BN.bSigned
	test eax,eax
	.if zero?
		; X = Y
		.if bnRem
			invoke bnClear,bnRem
		.endif
		invoke bnMovzx,bnQuo,1
		mov eax,bnQuo
		mov [eax].BN.bSigned,ebx
		ret
	.endif

	; (X < Y) OR (X = 0)
@@DivideZero:
	.if bnRem
		invoke bnMov,bnRem,bnX
	.endif
	invoke bnClear,bnQuo
	ret

@@DivisionByZero: 
	IFDEF DEBUG
	invoke bn_error,T('dbz')
	ENDIF
	xor edx,edx
	div edx
	ret
	
bnDiv endp
;
;	rem = x mod y
;
_a_
bnMod proc uses edi esi ebx bnX:DWORD,bnY:DWORD,bnRem:DWORD

	mov edi,bnY
	mov esi,bnX

	cmp [edi].BN.dwSize,1 ;	.if !BN_IS_ZERO(edi); DBZ
	jne @F
	cmp [edi].BN.dwArray[0],0
	je @@DivisionByZero
@@:	
	cmp [esi].BN.dwSize,1;	.if !BN_IS_ZERO(esi); DZ
	jne @F
	cmp [esi].BN.dwArray[0],0
	je @@DivideZero
@@:	
	
	invoke bnCmpAbs,bnX,bnY
	.if sdword ptr eax>0
 		; X > Y
		bnCreateX edi;tempRem
		invoke bnBits,esi
		lea ebx,[eax-1]
		.repeat
			invoke bnShl1,edi;tempRem
			bt [esi].BN.dwArray[0],ebx
			sbb eax,eax
			neg eax
			or [edi].BN.dwArray[0],eax
			invoke bnCmpAbs,edi,bnY
			test eax,eax
			.if !SIGN?
				invoke bnSub,edi,bnY
			.endif
			dec ebx
		.until SIGN?

		invoke bnMov,bnRem,edi

		mov eax,bnX
		mov edx,bnRem
		mov ebx,[eax].BN.bSigned
		mov [edx].BN.bSigned,ebx

		bnDestroyX
		ret
	.endif
	
	test eax,eax
	.if zero?
		; X = Y
		invoke bnClear,bnRem
		ret
	.endif

	; (X < Y) OR (X = 0)
@@DivideZero:
	invoke bnMov,bnRem,bnX
	ret

@@DivisionByZero: 
	IFDEF DEBUG
	invoke bn_error,T('#DBZ')
	ENDIF
	xor edx,edx
	div edx
	ret
	
bnMod endp
;
;	bn = bn*10
;
_a_ 
bnMul10 proc uses esi edi bn:DWORD
;	lea eax,[eax*4+eax]
;	add eax,eax
	invoke bnCreate
	mov esi,eax  
	mov edi,bn
	.if !BN_IS_ZERO(edi)
		invoke bnMov,esi,edi
		invoke bnShl,edi,2
		invoke bnAdd,edi,esi
		invoke bnShl1,edi
	.endif 
	invoke bnDestroy,esi
	ret
bnMul10 endp
;
;	add dword to bn
;	
_a_ 
bnAddAbsDw proc uses edi esi ebx bn:dword,dwVal:dword 
	mov edi,bn
	mov esi,bn
	mov ecx,[edi].BN.dwSize
	lea edi,[edi].BN.dwArray
	mov edx,dwVal
	xor eax,eax
	add [edi],edx
	dec ecx
	mov edx,eax
	lea edi,[edi+4]
	jz @F
	.repeat
		adc [edi],edx
		jnc @F
		lea edi,[edi+2]
		dec ecx
		lea edi,[edi+2]
	.until zero?
@@:
	adc eax,eax
	jnz @F
	mov eax,esi
	ret; most probable case
@@:
	mov edx,esi
	call bn_add_carry_dword
	ret
bnAddAbsDw endp
_a_; Standard Multiplication Algorithm
bn_muldw_basecase proc
	pushad
	mov ebp,[esp+pushad_ebx]
	xor ebx,ebx
	.repeat
		xor edx,edx
		mov eax,[esi].BN.dwArray[ebx*4-4+4]
		xor ecx,ecx
		inc ebx
		mul edi
		add eax,ecx
		adc edx,0
		add [ebp].BN.dwArray[0*4-4+4],eax
		adc edx,0
		add ebp,4
		mov [ebp].BN.dwArray[1*4-4],edx
	.until ebx >= [esi].BN.dwSize
	popad
	ret
bn_muldw_basecase endp
;
;	bn = bn * dword
;	
_a_ ; sign remains
bnMulDw proc uses edi esi ebx bn:dword,dwVal:dword
LOCAL tmpProd
	mov esi,bn
	mov edi,dwVal
	.if !BN_IS_ZERO(esi) && edi!=0 
		bnCreateX tmpProd
		mov ebx,eax
		mov eax,[esi].BN.dwSize
		inc eax
		.if eax <= BN_MAX_DWORD
			mov [ebx],eax
			call bn_muldw_basecase
			mov edx,tmpProd
			call bn_normalize
			invoke bnMov,bn,tmpProd
		.endif
		bnDestroyX
		ret
	.else
		invoke bnClear,bn
	.endif
	ret
bnMulDw endp
;
;	quo = bn div dwordY
;
_a_
bnDivDw proc uses edi esi ebx bnX:DWORD,valY:DWORD,bnQuo:DWORD;,bnRem:DWORD
LOCAL tempKvocijent,BitPos
	mov eax,bnQuo
	mov edi,valY
	mov tempKvocijent,eax
	mov esi,bnX
	test edi,edi
	mov edx,[esi].BN.dwArray[0]
	jz @@DivisionByZero
	cmp [esi].BN.dwSize,1
	jne @F
	test edx,edx
	je @@DivideZero
	.if edx>edi
@@:	
 		; X > Y
 		.if bnQuo
 			bnCreateX tempKvocijent;,edi;tempRem
		.endif
		invoke bnBits,esi
		xor edi,edi
		lea ebx,[eax-1]
		.repeat
		; for now just roughly addapted to 32
			shl edi,1
			bt [esi].BN.dwArray[0],ebx
			sbb eax,eax
			neg eax
			or edi,eax
			.if edi >= valY
				sub edi,valY
				mov eax,tempKvocijent
				.if eax
					bts [eax].BN.dwArray[0],ebx
				.endif
			.endif
			dec ebx
		.until SIGN?
		mov edx,tempKvocijent
		.if edx
			call bn_normalize
			invoke bnMov,bnQuo,tempKvocijent
	 		bnDestroyX
		.endif
 		mov eax,edi
		ret
	.endif

	.if edx == edi 
		; X = Y
		.if bnQuo
			invoke bnMovzx,bnQuo,1
		.endif
		xor eax,eax
		ret
	.endif

	; (X < Y) OR (X = 0)
@@DivideZero:
	mov edi,edx
	.if bnQuo
		invoke bnClear,bnQuo
	.endif
	mov eax,edi
	ret

@@DivisionByZero: 
	IFDEF DEBUG
	invoke bn_error,T('dbz32')
	ENDIF
	xor edx,edx
	div edx
	ret
	
bnDivDw endp

