.code
; 
;	arg1 = pointer to ascii hex string, zero terminated
;	arg2 = bn
;	converts ascii hex string to bn
;
_a_
Hex2bn proc uses edi esi ebx ptrStr:DWORD,bn:DWORD
	mov esi,bn
	mov edi,ptrStr
	invoke bnClear,esi
	mov al,[edi]
	mov edx,FALSE
	test al,al
	je @@Exit
	cmp al,'-'
	jne @F
	mov edx,TRUE
	.repeat
		inc edi     ; skip leading zero(s)
		mov al,[edi]
@@:	.until al != '0' 	
	mov	ecx,edi
	jmp @F
	.repeat
		inc ecx
@@:		mov al,[ecx]
	.until !al
	sub ecx,edi ; new length
	jz @@Exit
	mov [esi].BN.bSigned,edx
	mov eax,ecx ; {
	add ecx,7   ;
	and ecx,-8  ; align 8
	shr ecx,3   ; number of 8-char parts
	xor ebx,ebx
	mov [esi].BN.dwSize,ecx ; } bignum len (dwords)
	xor edx,edx
	lea esi,[esi].BN.dwArray[ecx*4-4]  ; point to last dword in array (MSD)
	.while eax
		movzx edx,byte ptr [edi]
		add edx, - 'a'
		jns @F
		add edx, 'a' - 'A'
		jns @F
		add edx,7
@@:		add edx,10
		dec eax
		shl ebx,4
		mov ecx,eax
		inc edi
		add ebx,edx
		and ecx,7; mod 8 ; wait for a dword
		.if zero?
			mov [esi],ebx        
			sub esi,4; LSD...MSD
		.endif
	.endw
	mov eax,esi
@@Exit:
	ret
Hex2bn endp
;
;	arg1 = bn
;	arg2 = pointer to output buffer
;	converts bn to hex string
;
_a_
bn2Hex proc uses edi esi ebx bn:DWORD, ptrStr:DWORD
	mov esi,bn
	mov edi,ptrStr
	mov edx,[esi].BN.dwSize
	.if [esi].BN.bSigned
		mov al,'-'
		stosb
	.endif
	mov ecx,[esi].BN.dwArray[edx*4-4]
	mov ebx,4
	bswap ecx
	.if cl == 0 
		shr ecx,8
		dec ebx
		.if cl == 0 
			shr ecx,8
			dec ebx
			.if cl == 0 
				shr ecx,8
				dec ebx
			.endif
		.endif
	.endif
	.repeat
		mov al,cl
		mov ah,al
		and ah,1111b
		shr al,4
		cmp al,9
		ja @F  
		add al,-7
@@:		add al,'A'-10
		cmp ah,9
		ja @F  
		add ah,-7
@@:		add ah,'A'-10
		mov [edi],ax
		add edi,2
		shr ecx,8
		dec ebx
	.until zero?
	jmp @@1
	.repeat
		mov cl,8
		mov ebx,[esi].BN.dwArray[edx*4-4]
	    .repeat
	    	mov al,bl
	    	and al,1111b
			cmp al,9
			ja @F  
			add al,-7
	@@:		shr ebx,4
			add al,'A'-10
			dec ecx
			mov [edi+ecx],al
	    .until zero?	
		add edi,8
@@1:	dec edx
	.until ZERO?
	mov eax,edi
	mov [edi],dl
	sub eax,ptrStr
	ret
bn2Hex endp
;
;	copies sequence of bytes to a bn
;
_a_ 
Bytes2bn proc uses edi esi pBytes:DWORD,dwBytesLen:dword,bn:DWORD,bSigned:dword
	invoke bnClear,bn
	mov ecx,dwBytesLen
	mov edi,bn
	mov eax,ecx
	mov esi,pBytes
	add eax,3
	and eax,-4
	shr eax,2
	mov [edi].BN.dwSize,eax
	movzx edx,byte ptr bSigned
	mov [edi].BN.bSigned,edx
	lea edi,[edi].BN.dwArray[0]
	rep movsb
	ret
Bytes2bn endp
;
;	copies bn to sequence of bytes
;	returns sign
;
_a_
bn2Bytes proc uses edi esi bn:DWORD, pBytes:DWORD
	mov esi,bn
	mov edi,pBytes
	mov ecx,[esi].BN.dwSize
	shl ecx,2
	lea esi,[esi].BN.dwArray[0]
	rep movsb
	mov eax,[esi].BN.bSigned
	ret
bn2Bytes endp
;
;	converts sequence of bytes to a bn bswap-ed
;
_a_
Bytes2bnEx proc uses edi esi pBytes:DWORD,dwBytesLen:dword,bn:DWORD,bSigned:dword
	invoke bnClear,bn
	mov edx,BN_ALLOC_BYTES
	mov ecx,dwBytesLen
	sub edx,4
	mov esi,pBytes
	sub edx,ecx
	.if !sign?
		mov edx,ecx
		mov edi,bn
		shr edx,2
		lea edi,[edi].BN.dwArray
		lea esi,[esi+ecx]
		.if !zero?
			mov [edi-BN.dwArray],edx
		@@:
			mov eax,[esi-4]
			sub esi,4
			bswap eax
			stosd
			dec edx
			jnz @B
		.endif
		and ecx,3
		.if !zero?
			neg ecx
		@@:
			mov al,[esi+ecx]
			stosb
			inc ecx
			jnz @B
			mov edi,bn
			inc [edi].BN.dwSize
		.endif
		mov eax,bSigned
		mov [edi].BN.bSigned,eax
	.endif
	ret
Bytes2bnEx endp
;
;	converts bn to sequence of bytes bswap-ed
;	returns sign
_a_ 
bn2BytesEx proc uses esi edi bn:dword,pBytes:dword
	mov esi,bn
	mov edi,pBytes
	mov ecx,[esi].BN.dwSize
	mov edx,[esi].BN.bSigned
	lea esi,[esi].BN.dwArray[ecx*4-4]
	mov al,[esi+3]
	.if ! (al == 0 && edi == pBytes)
		stosb
	.endif
	mov al,[esi+2]
	.if ! (al == 0 && edi == pBytes)
		stosb
	.endif
	mov al,[esi+1]
	.if ! (al == 0 && edi == pBytes)
		stosb
	.endif
	mov al,[esi]
	stosb
	.repeat
		dec ecx
		.break .if zero?
		mov eax,[esi-4]
		sub esi,4
		bswap eax
		stosd
	.until 0
	mov eax,edx
	ret
bn2BytesEx endp
;
;	arg1 = pointer to base10 string, zero terminated
;	arg2 = bn
;	converts ascii string to bn
;
_a_ 
Str2bn proc uses ebx edi esi ptrStr:DWORD, bn:DWORD
	mov edi,bn
	mov esi,ptrStr
	invoke bnClear,edi
	.if word ptr [esi]=='0'
		ret
	.endif
	.if byte ptr [esi]=='-'
		inc esi
		mov byte ptr [edi].BN.bSigned,TRUE
	.endif
	.while BYTE PTR [esi]=='0' ; call StrDel0 
		inc esi
	.endw
	.while 1;<>0
		movzx ebx,byte ptr [esi]
		.break .if !ebx
		sub ebx,'0'
		add esi,1
		invoke bnMul10,edi
		invoke bnAddAbsDw,edi,ebx
	.endw  
	ret
Str2bn endp
;
;	analogue to bn2Hex
;
_a_ 
bn2Str proc uses ebx edi esi bn:DWORD, ptrStr:DWORD
LOCAL ten:DWORD, tmp:DWORD
	mov esi,bn
	mov ebx,ptrStr
	.if BN_IS_ZERO(esi)
		mov word ptr [ebx],'0'
		ret
	.endif
	.if [esi].BN.bSigned
		mov byte ptr [ebx],'-'
		inc ebx
		inc ptrStr
	.endif
	invoke bnCreatei,10
	mov ten,eax
	bnCreateX edi,tmp
	invoke bnMov,tmp,esi
	mov esi,tmp
	.while !BN_IS_ZERO(esi)
		invoke bnDiv,esi,ten,esi,edi
		mov eax,[edi].BN.dwArray 
		add al,'0'
		mov [ebx],al
		inc ebx
	.endw  
	and byte ptr [ebx],0
	mov esi,ptrStr
	mov eax,ebx
	sub eax,esi
	shr eax,1
	.if !zero?
		.repeat
			dec ebx
			mov dl, [esi]
			mov cl, [ebx]
			inc esi
			mov [ebx], dl
			mov [esi-1], cl
			dec eax
		.until ZERO?
	.endif
	invoke bnDestroy,ten   
	bnDestroyX
	ret
bn2Str endp

