.code
;
;	result=gcd(x,y)
;	greatest common divisor (x,y)
;	Modern Euclidean Algorithm 
;	
_a_
bnGCD proc uses ebx edi esi bnX:DWORD, bnY:DWORD, bnResult:DWORD
	bnCreateX edi,ebx,esi
	invoke bnMov,edi,bnX
	invoke bnMov,esi,bnY
	.while !BN_IS_ZERO(esi)
		invoke bnMod,edi,esi,ebx
		invoke bnMov,edi,esi
		invoke bnMov,esi,ebx
	.endw
	invoke bnMov,bnResult,edi
	bnDestroyX
	ret
bnGCD endp
;
;	least common multiple
;
_a_
bnLCM proc uses edi esi bnX:DWORD, bnY:DWORD, bnR:DWORD
	bnCreateX edi,esi
	invoke bnGCD,bnX,bnY,edi
	invoke bnMul,bnX,bnY,esi
	invoke bnDiv,esi,edi,bnR,0
	bnDestroyX
	ret
bnLCM endp
;
;	EQUALS POWMOD
;	bnResult = bnX^bnExp mod bnModulus
;	
_a_
bnModExp proc uses ebx edi esi bnX:DWORD, bnExp:DWORD, bnModulus:DWORD, bnResult:DWORD
	mov eax,bnModulus
	.if ! BN_IS_ZERO(eax)
		.if BN_IS_ODD(eax)
			invoke bnMontyModExp,bnX,bnExp,bnModulus,bnResult
			ret
		.endif
		invoke bnCreatei,1
		mov esi,bnExp
		mov edi,eax
		.if ! BN_IS_ZERO(esi)
			invoke bnBits,esi
			lea ebx,[eax-1]
			jmp @F
			.repeat  
				invoke bnSquare,edi
				invoke bnMod,edi,bnModulus,edi
			@@:
				bt [esi].BN.dwArray[0],ebx
				.if CARRY?
					invoke bnMul,edi,bnX,edi
					invoke bnMod,edi,bnModulus,edi
				.endif
				dec ebx
			.until SIGN?
		.endif  
		xor eax,eax
		invoke bnMov,bnResult,edi
		invoke bnDestroy,edi
	.endif
	ret
bnModExp endp
;
;	TERM!!!! -> GCD(x,n)==1
;	r = 1/x mod n
;	modular inverse
;	
_a_
bnModInv proc uses ebx edi esi bnX:DWORD, bnN:DWORD, bnR:DWORD
LOCAL t0,t1:DWORD
;	invoke bnGCD,bnX,bnN,bnR
;	mov eax,bnR
;	.if BN_IS_ONE(eax); 
		invoke bnCreatei,1
		mov t1,eax
		bnCreateX ebx,edi,esi,t0
		invoke bnMov,ebx,bnX
		invoke bnMov,esi,bnN
		.while TRUE
			.if BN_IS_ONE(ebx)
				invoke bnMov,bnR,t1
				.break
			.endif
			invoke bnDiv,esi,ebx,edi,esi
			invoke bnMul,edi,t1,bnR
			invoke bnAdd,t0,bnR
			.if BN_IS_ONE(esi)
				invoke bnMov,bnR,bnN
				invoke bnSub,bnR,t0 ; never <0
				.break
			.endif
			invoke bnDiv,ebx,esi,edi,ebx
			invoke bnMul,edi,t0,bnR
			invoke bnAdd,t1,bnR
		.endw   
		bnDestroyX
		ret
;	.endif 
;	invoke bnClear,bnR
;	ret
bnModInv endp
;
;	calculates rx and ry such that : x*rx + y*ry = 1
;	Extended Euclidean Algorithm
;
_a_
bnXGCD proc uses ebx edi esi bnX:DWORD,bnY:DWORD,bnRx:DWORD,bnRy:DWORD
LOCAL up,u,xp,x,yp,y,quo,tmp,tmp2,tmp3

	bnCreateX up,u,xp,x,yp,y,quo,tmp,tmp2,tmp3
	invoke bnMov,up,bnX
	invoke bnMov,u,bnY
	xor eax,eax
	mov esi,x
	inc eax
	mov edi,yp
	mov [esi].BN.dwArray[0],eax
	mov [edi].BN.dwArray[0],eax
	mov edx,u
	.while ! BN_IS_ZERO(edx)
		invoke bnDiv,up,u,quo,tmp
		invoke bnMov,up,u
		invoke bnMov,u,tmp
		;-
		invoke bnMov,tmp,xp
		invoke bnMul,x,quo,tmp2
		invoke bnSub,tmp,tmp2
		invoke bnMov,xp,x
		invoke bnMov,x,tmp
		;-
		invoke bnMov,tmp,yp
		invoke bnMul,y,quo,tmp2
		invoke bnSub,tmp,tmp2
		invoke bnMov,yp,y
		invoke bnMov,y,tmp
		mov edx,u
	.endw   
	invoke bnMov,bnRx,xp
	invoke bnMov,bnRy,yp

	bnDestroyX
	ret
bnXGCD endp
;
;	combined mul+mod	
;	
_a_ 
bnMulMod proc uses ebx bnX:DWORD, bnY:DWORD, bnN:DWORD, bnR:DWORD
	invoke bnCreate
	mov ebx,eax
	invoke bnClear,ebx
	invoke bnMul,bnX,bnY,ebx
	invoke bnMod,ebx,bnN,bnR
	invoke bnDestroy,ebx 
	ret
bnMulMod endp
